##
#   File:       BadAPPL.make
#   Target:     BadAPPL
#   Sources:    BadAPPL.c
#               BadErrors.c
#               BadGestalt.c
#               BadUtils.c
#               BadWindows.c
#   Created:    Saturday, December 11, 1993 4:42:43 PM
##
#	To Build:	make -f BadAPPL.make BadAPPL
##

DestFile = "BadAPPL.MPW"
SymOn = -sym on
CompileOptions = -opt full

# define QCAPIDIR as the location of where you put the QCAPI headers/libraries
# This may just end up being {CLibraries} but it's your choice.
QCAPIDIR = "{QCCommonDir}"

INCLUDEPATH = 
		-i : 
		-i {QCAPIDIR}

OBJECTDIR = :Obj:

ALLHEADERS =  
	BadAPPL.h 
	BadDefs.h 
	BadErrors.h 
	BadGestalt.h 
	BadGlobs.h 
	BadIncludes.h 
	BadMacros.h 
	BadUtils.h 
	BadWindows.h 
	{QCAPIDIR}QCAPI.h

OBJECTS = 
	{OBJECTDIR}BadAPPL.c.o 
	{OBJECTDIR}BadErrors.c.o 
	{OBJECTDIR}BadGestalt.c.o 
	{OBJECTDIR}BadUtils.c.o 
	{OBJECTDIR}BadWindows.c.o 
	{QCAPIDIR}QCAPI.o

BadAPPL  BadAPPL.make {OBJECTS}
	echo "# Linking {Targ}"
	Link -t APPL -c Bapp {SymOn} 
		{OBJECTS} 
		"{CLibraries}"StdClib.o 
		"{Libraries}"Runtime.o 
		"{Libraries}"ToolLibs.o 
		"{Libraries}"Interface.o 
		-o ::{DestFile}
	echo "# Including resources...";
	echo "include "::BadAPPL.rsrc";" > "temp.out";
	rez "temp.out" -a -o ::{DestFile}; delete "temp.out";
	echo "# '{DestFile}' build complete.";


{OBJECTDIR}BadAPPL.c.o  BadAPPL.make BadAPPL.c {ALLHEADERS}
	echo "# Compiling {Targ}"
	C -r {SymOn} {CompileOptions} BadAPPL.c {INCLUDEPATH} -o {OBJECTDIR}
{OBJECTDIR}BadErrors.c.o  BadAPPL.make BadErrors.c {ALLHEADERS}
	echo "# Compiling {Targ}"
	 C -r {SymOn} {CompileOptions} BadErrors.c {INCLUDEPATH} -o {OBJECTDIR}
{OBJECTDIR}BadGestalt.c.o  BadAPPL.make BadGestalt.c {ALLHEADERS}
	echo "# Compiling {Targ}"
	 C -r {SymOn} {CompileOptions} BadGestalt.c {INCLUDEPATH} -o {OBJECTDIR}
{OBJECTDIR}BadUtils.c.o  BadAPPL.make BadUtils.c {ALLHEADERS}
	echo "# Compiling {Targ}"
	 C -r {SymOn} {CompileOptions} BadUtils.c {INCLUDEPATH} -o {OBJECTDIR}
{OBJECTDIR}BadWindows.c.o  BadAPPL.make BadWindows.c {ALLHEADERS}
	echo "# Compiling {Targ}"
	 C -r {SymOn} {CompileOptions} BadWindows.c {INCLUDEPATH} -o {OBJECTDIR}

